<?php
/**
 *
 * @ 短信宝接口 For SMS  Center
 * @ Author     : imnpc
 * @ Release on : 2016/1/12 13:21
 * @ Website    : http://www.imnpc.me
 *
 **/
class MG_SMS_SmsBao extends MG_SMS_Submodule
{
    //默认变量
    public static $name = '短信宝(China)'; //模块名
    public static $description =
        '<a href="http://www.smsbao.com/reg?r=10232">www.smsbao.com</a>'; //模块描述
    public static $link =
        '<a style=" color: #4169E1;" target="_blank" href="http://www.smsbao.com/reg?r=10232">注册一个短信宝账户</a>'; //模块连接 用在推荐页
    public static $img = 'http://www.smsbao.com/style_sb/images/logo.png'; //模块logo  用在推荐页
    public static $bgColor = ""; //背景色 用在推荐页 #0D4254
    public static $featured = true; //是否推荐
    public static $featuredDescription =
        '超过9,000个网站始终信任短信宝。通过稳定快捷的短信，短信宝帮助他们缩短了90%的人工服务处理时间，同时降低了81%由于通讯故障导致的废单率，一切变得轻松可控！'; //模块介绍 用在推荐页

    protected $errorCodes = array(
        "0" => "0 账户验证通过或短信发送成功",
        "-1" => "-1 参数不全",
        "-2" => "-2 服务器空间不支持,请确认支持curl或者fsocket，联系您的空间商解决或者更换空间！",
        "30" => "30 密码错误",
        "40" => "40 账号不存在",
        "41" => "41 余额不足",
        "42" => "42 帐户已过期",
        "43" => "43 IP地址限制",
        "50" => "50 内容含有敏感词");

    /**
     * This function is fired when "Check Connection" button is cliked
     * 
     * Error codes:
     * MG_SMS_SubmoduleErrorCodes::INVALID_DETAILS -> 1
     * MG_SMS_SubmoduleErrorCodes::INVALID_COMMAND -> 2
     * MG_SMS_SubmoduleErrorCodes::INVALID_PARAMS -> 3
     * 
     * throw exception when checkConnection fails
     * @throws Exception, MG_SMS_SubmoduleException
     */
    //检测SMS接口联通状态 http://www.smsbao.com/query?u=USERNAME&p=PASSWORD

    public function checkConnection()
    {
        $result = $this->CheckCredits(array('u' => $this->configuration['username'], 'p' =>
                md5($this->configuration['password'])));

        if ($this->errorCodes[$result] > 0)
        {
            throw new MG_SMS_SubmoduleException($this->errorCodes[$result]);
            return null;
        }

        return $this->errorCodes[$result];
    }
    /**
     * This function is fired when "Configuration" button is clicked
     * 
     * Available types:
     * MG_SMS_SubmoduleConfiguration::TYPE_TEXT -> this is defaul type
     * MG_SMS_SubmoduleConfiguration::TYPE_SELECT
     * MG_SMS_SubmoduleConfiguration::TYPE_PASSWORD
     * 
     * @return array 
     */
    //短信宝配置
    public static function getConfiguration()
    {
        return array(
            'username' => array('type' => MG_SMS_SubmoduleConfiguration::TYPE_TEXT,
                    'validators' => array('required')), //短信系统用户名
            'password' => array('type' => MG_SMS_SubmoduleConfiguration::TYPE_PASSWORD,
                    'validators' => array('required')), //短信系统密码
            'sender' => array('type' => MG_SMS_SubmoduleConfiguration::TYPE_TEXT,
                    'validators' => array('required'))); //短信签名
    }

    /**
     * This function is fired when module wants to send sms
     * 
     * throw exception when sending smsm fails
     * 
     * @param type $sms - text to send
     * @param type $number - client number (only numbers, without leading zeros or +)
     * @throws Exception, MG_SMS_SubmoduleException
     */
    //发送短信 http://api.smsbao.com/sms?u=USERNAME&p=PASSWORD&m=PHONE&c=CONTENT
    public function sendMessage($sms, $number)
    {
        $number = substr($number, 2); //去掉国家代码
        $sms = $sms . $this->configuration['sender'];
        $username = $this->configuration['username'];
        $password = md5($this->configuration['password']);
        $params = array(
            'u' => $username,
            'p' => $password,
            'm' => $number,
            'c' => $sms);
        $result = $this->request($params);

        if ($this->errorCodes[$result])
        {
            throw new MG_SMS_SubmoduleException($this->errorCodes[$result]);
            return null;
        }
        return $result;
    }
    //发送接口
    function request($params = array())
    {
        $query = http_build_query($params);
        $url = 'http://api.smsbao.com/sms?' . $query;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);
        $result = curl_exec($ch);
        curl_close($ch);

        if ($this->errorCodes[$result] > 0)
        {
            throw new MG_SMS_SubmoduleException($this->errorCodes[$result]);
            return null;
        }

        return json_decode($this->errorCodes[$result], true);
    }

    //查询接口
    function CheckCredits($params = array())
    {
        $query = http_build_query($params);
        $url = 'http://www.smsbao.com/query?' . $query;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);
        $result = curl_exec($ch);
        curl_close($ch);

        if ($this->errorCodes[$result] > 0)
        {
            throw new MG_SMS_SubmoduleException($this->errorCodes[$result]);
            return null;
        }

        return json_decode($this->errorCodes[$result], true);
    }

    //短信接口详细信息
    public function getGatewayDetails()
    {
        return array(
            'name' => self::$name,
            'description' => self::$description,
            'link' => self::$link,
            'img' => self::$img,
            'bgColor' => self::$bgColor,
            'featured' => self::$featured,
            'featuredDescription' => self::$featuredDescription,
            );
    }
}
